 PROGRAM Motorola_SRecords_zu_MOPS_Datei_konvertieren;
 uses crt;

 VAR SRecFile              : Text;
     MopsAdresse,MOPSZeiger: LongInt;
     Anzahl,Adresse        : LongInt;
     MOPSFile              : File OF Byte;
     B                     : Byte;
     srecname,MopsName     : String;


 PROCEDURE SRecKonvert;
 VAR ch                     : Char;
     i,Laenge,Startadresse  : LongInt;
     Start,Ende             : Boolean;

     PROCEDURE lies(var ch: char);
     BEGIN
       Read(SRecFile,ch);
       write(ch);
     END;

     FUNCTION LiesNibble: LongInt;
     VAR w: Longint;
     BEGIN
       IF NOT Ende
         THEN BEGIN
                Lies(ch);
                CASE ch OF
                  '0'..'9': w:=Ord(ch)-Ord('0');
                  'A'..'F': w:=Ord(ch)-Ord('A')+10;
                  ELSE Ende:=True
                END
              END;
       LiesNibble:=w;
     END;

     FUNCTION LiesByte: LongInt;
     VAR w: LongInt;
     BEGIN
       w:=LiesNibble;
       w:=w*16+LiesNibble;
       LiesByte:=w;
     END;

     PROCEDURE Kopf;
     BEGIN
       WHILE ch >= #32 DO Lies(ch)
     END;

     PROCEDURE writeint(l: LongInt);
     VAR b: Byte;
     BEGIN
        b:= l AND $FF;
        write(MopsFile,b);
        b:=(l shr 8) AND $FF;
        write(MopsFile,b);
     END;

     PROCEDURE LiesInhalt;
     VAR i,ChkSum: LongInt;
         b: Byte;
     BEGIN
       IF Start THEN BEGIN Startadresse:=Adresse; Mopsadresse:=Adresse END;
       Start:=False;
       IF Mopsadresse <> Adresse
          THEN BEGIN
                 writeln;
                 writeln('Die S-Recorddatei enthlt keinen zusammenhngenden Code',#7);
                 Ende:=true
               END;
       FOR i:=1 TO Anzahl-1 DO   (* Letztes Zeichen = Prfbyte *)
         BEGIN b:=LiesByte;
               write(MopsFile,b);
               Inc(Mopszeiger); Inc(Mopsadresse); Inc(Laenge);
         END;
       ChkSum:=LiesByte;         (* ignorieren *)
     END;

     PROCEDURE Adr16;
     BEGIN
       Anzahl:=LiesByte-2;              (* 2 Byte Adresse *)
       Adresse:=LiesByte;
       Adresse:=Adresse*256+LiesByte;
       LiesInhalt
     END;

     PROCEDURE Adr24;
     BEGIN
       Anzahl:=LiesByte-3;              (* 3 Byte Adresse *)
       Adresse:=LiesByte;
       Adresse:=Adresse shl 8 + LiesByte;
       Adresse:=Adresse shl 8 + LiesByte;
       LiesInhalt
     END;

     PROCEDURE Adr32;
     BEGIN
       Anzahl:=LiesByte-4;              (* 4 Byte Adresse *)
       Adresse:=LiesByte;
       Adresse:=Adresse shl 8 + LiesByte;
       Adresse:=Adresse shl 8 + LiesByte;
       Adresse:=Adresse shl 8 + LiesByte;
       LiesInhalt
     END;

     PROCEDURE LiesRec;
     BEGIN
       Ende:=(ch<>'S');
       IF Not Ende THEN
         BEGIN Lies(Ch);
               Case Ch OF
                 '0': Kopf;
                 '1': Adr16;
                 '2': Adr24;
                 '3': Adr32;
                 ELSE Ende:=True;
               END;
         END;
     END;

 BEGIN   (* SRecKonvert *)
   b:=0;
   FOR i:=0 TO 127 DO write(MopsFile,b);  (* Block 0 ueberspringen *)
   Mopszeiger:=0;
   Start:=True;
   Ende:=False;
   REPEAT
     REPEAT Lies(ch) UNTIL Ch IN ['A'..'z'];
     LiesRec;
   UNTIL Ende;
   Laenge:=Mopszeiger;
   b:=0;
   WHILE Mopszeiger AND $1FF <> 0 DO    (* 512-er Bloecke bilden *)
    BEGIN write(MopsFile,b); Inc(Mopszeiger) END;
   Close(Mopsfile);
   Reset(MopsFile);                     (* an Anfang springen *)
   writeln;
   writeln('Startadresse=',startadresse);
   writeln('Laenge      =',Laenge);
   writeint(Startadresse);   (* Werte in Block 0 schreiben *)
   writeInt(Laenge);
 END;

 BEGIN  (* Hauptprogram *)
    clrscr;
    writeln('***** Konvertieren von Motorola S-Records in MOPS Datei *****');
    writeln;
    writeln('Name des S-Record-Files:');
    readln(srecname);
    assign(SRecFile, SRecName);
    reset(srecfile);
    writeln('Name der MOPS-Ce Datei: ');
    readln(MopsName);
    assign(MopsFile,MopsName);
    Rewrite(MopsFile);
    SRecKonvert;
    Close(SRecFile);
    Close(MopsFile);
    writeln; writeln ('RETURN..'); readln;
 END.
